<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/IDL/idltype.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/IDL/idltype.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/IDL/idltype.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment"># -*- python -*-</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment">#                           Package   : omniidl</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># idltype.py                Created on: 1999/10/27</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment">#			    Author    : Duncan Grisby (dpg1)</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment">#</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#    Copyright (C) 1999 AT&amp;T Laboratories Cambridge</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-comment">#  This file is part of omniidl.</span></span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-comment">#</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-comment">#  omniidl is free software; you can redistribute it and/or modify it</span></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-comment">#  under the terms of the GNU General Public License as published by</span></span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-comment">#  the Free Software Foundation; either version 2 of the License, or</span></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-comment">#  (at your option) any later version.</span></span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-comment">#</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-comment">#  This program is distributed in the hope that it will be useful,</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-comment">#  but WITHOUT ANY WARRANTY; without even the implied warranty of</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-comment">#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-comment">#  General Public License for more details.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-comment">#</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-comment">#  You should have received a copy of the GNU General Public License</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-comment">#  along with this program; if not, write to the Free Software</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-comment">#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-comment">#  02111-1307, USA.</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-comment">#</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-comment"># Description:</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-comment">#   </span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-comment">#   IDL type representation</span></span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">&quot;&quot;&quot;Definitions for IDL type representation</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-string"/></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-string">Classes:</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string"/></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-string">  Type     -- abstract base class.</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-string">  Base     -- class for CORBA base types.</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">  String   -- class for string types.</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">  WString  -- class for wide string types.</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-string">  Sequence -- class for sequence types.</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">  Fixed    -- class for fixed-point types.</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-string">  Declared -- class for declared types.</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="py-string"/></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-string">TypeCode kind constants:</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-string"/></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="py-string">  tk_null, tk_void, tk_short, tk_long, tk_ushort, tk_ulong, tk_float,</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-string">  tk_double, tk_boolean, tk_char, tk_octet, tk_any, tk_TypeCode,</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-string">  tk_Principal, tk_objref, tk_struct, tk_union, tk_enum, tk_string,</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">  tk_sequence, tk_array, tk_alias, tk_except, tk_longlong,</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="py-string">  tk_ulonglong, tk_longdouble, tk_wchar, tk_wstring, tk_fixed,</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-string">  tk_value, tk_value_box, tk_native, tk_abstract_interface&quot;&quot;&quot;</span></span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-keyword">import</span> idlutil</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">tk_null               = 0</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">tk_void               = 1</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">tk_short              = 2</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">tk_long               = 3</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">tk_ushort             = 4</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">tk_ulong              = 5</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">tk_float              = 6</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">tk_double             = 7</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">tk_boolean            = 8</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">tk_char               = 9</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">tk_octet              = 10</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">tk_any               = 11</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">tk_TypeCode           = 12</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">tk_Principal          = 13</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">tk_objref             = 14</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">tk_struct             = 15</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">tk_union              = 16</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">tk_enum               = 17</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">tk_string             = 18</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">tk_sequence           = 19</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">tk_array              = 20</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">tk_alias              = 21</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">tk_except             = 22</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">tk_longlong           = 23</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">tk_ulonglong          = 24</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">tk_longdouble         = 25</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">tk_wchar              = 26</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">tk_wstring            = 27</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">tk_fixed              = 28</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">tk_value              = 29</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">tk_value_box          = 30</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">tk_native             = 31</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">tk_abstract_interface = 32</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">tk_local_interface    = 33</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line"><span class="py-comment"># Non-standard kinds for forward-declared structs and unions</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">ot_structforward      = 100</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">ot_unionforward       = 101</span>
<a id="line90"></a><span class="lineno"> 90</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Error.html">Error</a>:</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Exception class used by IdlType internals.&quot;&quot;&quot;</span></span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Error.html#__init__">__init__</a>(self, err):</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        self.err = err</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Error.html#__repr__">__repr__</a>(self):</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">return</span> self.err</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html">Type</a>:</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Type abstract class.</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line"><span class="py-string"/></span>
<a id="line105"></a><span class="lineno">105</span><span class="line"><span class="py-string">Function:</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line"><span class="py-string"/></span>
<a id="line107"></a><span class="lineno">107</span><span class="line"><span class="py-string">  kind()          -- TypeCode kind of type.</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line"><span class="py-string">  unalias()       -- Return an equivalent Type object with aliases stripped</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line"><span class="py-string">  accept(visitor) -- visitor pattern accept. See idlvisitor.py.&quot;&quot;&quot;</span></span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html#__init__">__init__</a>(self, kind, local):</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        self.__kind  = kind</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        self.__local = local</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html#kind">kind</a>(self):            <span class="py-keyword">return</span> self.__kind</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html#local">local</a>(self):           <span class="py-keyword">return</span> self.__local</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html#unalias">unalias</a>(self):</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        type = self</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">while</span> type.kind() == tk_alias:</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">            <span class="py-keyword">if</span> len(type.decl().sizes()) &gt; 0:</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">                <span class="py-keyword">return</span> type</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">            type = type.decl().alias().aliasType()</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        <span class="py-keyword">return</span> type</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Type.html#accept">accept</a>(self, visitor): <span class="py-keyword">pass</span></span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line"><span class="py-comment"># Base types</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Base.html">Base</a> (Type):</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for CORBA base types. (Type)</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line"><span class="py-string"/></span>
<a id="line133"></a><span class="lineno">133</span><span class="line"><span class="py-string">No non-inherited functions.&quot;&quot;&quot;</span></span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Base.html#__init__">__init__</a>(self, kind):</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        <span class="py-keyword">if</span> kind <span class="py-keyword">not</span> <span class="py-keyword">in</span> [tk_null, tk_void, tk_short, tk_long, tk_ushort,</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">                        tk_ulong, tk_float, tk_double, tk_boolean,</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">                        tk_char, tk_octet, tk_any, tk_TypeCode,</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">                        tk_Principal, tk_longlong, tk_ulonglong,</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">                        tk_longdouble, tk_wchar]:</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            <span class="py-keyword">raise</span> Error(<span class="py-string">&quot;Attempt to create Base type with invalid kind.&quot;</span>)</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">        Type.__init__(self, kind, 0)</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Base.html#accept">accept</a>(self, visitor): visitor.visitBaseType(self)</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span>
<a id="line149"></a><span class="lineno">149</span><span class="line"><span class="py-comment"># Strings can be used like base types without a declaration. eg:</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line"><span class="py-comment">#</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line"><span class="py-comment">#   void op(in string&lt;10&gt; s);</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line"><span class="py-comment">#</span></span>
<a id="line153"></a><span class="lineno">153</span><span class="line"><span class="py-comment"># therefore, the String type must include its bound here, rather than</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line"><span class="py-comment"># relying on looking at the corresponding declaration</span></span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/String.html">String</a> (Type):</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for string types (Type)</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line"><span class="py-string"/></span>
<a id="line159"></a><span class="lineno">159</span><span class="line"><span class="py-string">Function:</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line"><span class="py-string"/></span>
<a id="line161"></a><span class="lineno">161</span><span class="line"><span class="py-string">  bound() -- bound of bounded string. 0 for unbounded.&quot;&quot;&quot;</span></span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/String.html#__init__">__init__</a>(self, bound):</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        Type.__init__(self, tk_string, 0)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        self.__bound = bound</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/String.html#accept">accept</a>(self, visitor): visitor.visitStringType(self)</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/String.html#bound">bound</a>(self): <span class="py-keyword">return</span> self.__bound</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/WString.html">WString</a> (Type):</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for wide string types (Type)</span></span>
<a id="line172"></a><span class="lineno">172</span><span class="line"><span class="py-string"/></span>
<a id="line173"></a><span class="lineno">173</span><span class="line"><span class="py-string">Function:</span></span>
<a id="line174"></a><span class="lineno">174</span><span class="line"><span class="py-string"/></span>
<a id="line175"></a><span class="lineno">175</span><span class="line"><span class="py-string">  bound() -- bound of bounded wstring. 0 for unbounded.&quot;&quot;&quot;</span></span>
<a id="line176"></a><span class="lineno">176</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/WString.html#__init__">__init__</a>(self, bound):</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        Type.__init__(self, tk_wstring, 0)</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        self.__bound = bound</span>
<a id="line180"></a><span class="lineno">180</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/WString.html#accept">accept</a>(self, visitor): visitor.visitWStringType(self)</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/WString.html#bound">bound</a>(self): <span class="py-keyword">return</span> self.__bound</span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line"><span class="py-comment"># Sequences are never declared. They either appear as</span></span>
<a id="line186"></a><span class="lineno">186</span><span class="line"><span class="py-comment">#</span></span>
<a id="line187"></a><span class="lineno">187</span><span class="line"><span class="py-comment">#   typedef sequence &lt;...&gt; ...</span></span>
<a id="line188"></a><span class="lineno">188</span><span class="line"><span class="py-comment">#</span></span>
<a id="line189"></a><span class="lineno">189</span><span class="line"><span class="py-comment"># or inside a struct, union, or valuetype</span></span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Sequence.html">Sequence</a> (Type):</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for sequence types (Type)</span></span>
<a id="line193"></a><span class="lineno">193</span><span class="line"><span class="py-string"/></span>
<a id="line194"></a><span class="lineno">194</span><span class="line"><span class="py-string">Functions:</span></span>
<a id="line195"></a><span class="lineno">195</span><span class="line"><span class="py-string"/></span>
<a id="line196"></a><span class="lineno">196</span><span class="line"><span class="py-string">  seqType() -- Type this is a sequence of.</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line"><span class="py-string">  bound()   -- bound of bounded sequence. 0 for unbounded.&quot;&quot;&quot;</span></span>
<a id="line198"></a><span class="lineno">198</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Sequence.html#__init__">__init__</a>(self, seqType, bound, local):</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">        Type.__init__(self, tk_sequence, local)</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">        self.__seqType = seqType</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">        self.__bound   = bound</span>
<a id="line203"></a><span class="lineno">203</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Sequence.html#accept">accept</a>(self, visitor): visitor.visitSequenceType(self)</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Sequence.html#seqType">seqType</a>(self): <span class="py-keyword">return</span> self.__seqType</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Sequence.html#bound">bound</a>(self):   <span class="py-keyword">return</span> self.__bound</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span>
<a id="line209"></a><span class="lineno">209</span><span class="line"><span class="py-comment"># Same goes for fixed</span></span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Fixed.html">Fixed</a> (Type):</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for fixed point types (Type)</span></span>
<a id="line213"></a><span class="lineno">213</span><span class="line"><span class="py-string"/></span>
<a id="line214"></a><span class="lineno">214</span><span class="line"><span class="py-string">Functions:</span></span>
<a id="line215"></a><span class="lineno">215</span><span class="line"><span class="py-string"/></span>
<a id="line216"></a><span class="lineno">216</span><span class="line"><span class="py-string">  digits() -- digits.</span></span>
<a id="line217"></a><span class="lineno">217</span><span class="line"><span class="py-string">  scale()  -- scale.&quot;&quot;&quot;</span></span>
<a id="line218"></a><span class="lineno">218</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Fixed.html#__init__">__init__</a>(self, digits, scale):</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        Type.__init__(self, tk_fixed, 0)</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        self.__digits = digits</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">        self.__scale  = scale</span>
<a id="line223"></a><span class="lineno">223</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Fixed.html#accept">accept</a>(self, visitor): visitor.visitFixedType(self)</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Fixed.html#digits">digits</a>(self): <span class="py-keyword">return</span> self.__digits</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Fixed.html#scale">scale</a>(self):  <span class="py-keyword">return</span> self.__scale</span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line"><span class="py-comment"># All other types must be declared, at least implicitly, so they have</span></span>
<a id="line230"></a><span class="lineno">230</span><span class="line"><span class="py-comment"># an associated declaration object</span></span>
<a id="line231"></a><span class="lineno">231</span>
<a id="line232"></a><span class="lineno">232</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html">Declared</a> (Type):</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for declared types (Type)</span></span>
<a id="line234"></a><span class="lineno">234</span><span class="line"><span class="py-string"/></span>
<a id="line235"></a><span class="lineno">235</span><span class="line"><span class="py-string">Functions:</span></span>
<a id="line236"></a><span class="lineno">236</span><span class="line"><span class="py-string"/></span>
<a id="line237"></a><span class="lineno">237</span><span class="line"><span class="py-string">  decl()       -- Decl object which corresponds to this type.</span></span>
<a id="line238"></a><span class="lineno">238</span><span class="line"><span class="py-string">  scopedName() -- Fully scoped name of the type as a list of strings.</span></span>
<a id="line239"></a><span class="lineno">239</span><span class="line"><span class="py-string">  name()       -- Simple name of the type.&quot;&quot;&quot;</span></span>
<a id="line240"></a><span class="lineno">240</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html#__init__">__init__</a>(self, decl, scopedName, kind, local):</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">        <span class="py-keyword">if</span> kind <span class="py-keyword">not</span> <span class="py-keyword">in</span> [tk_objref, tk_struct, tk_union, tk_enum,</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">                        tk_array, tk_alias, tk_except, tk_value,</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">                        tk_value_box, tk_native, tk_abstract_interface,</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">                        tk_local_interface, ot_structforward,</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">                        ot_unionforward]:</span>
<a id="line247"></a><span class="lineno">247</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">            <span class="py-keyword">raise</span> Error(<span class="py-string">&quot;Attempt to create Declared type with invalid kind.&quot;</span>)</span>
<a id="line249"></a><span class="lineno">249</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">        Type.__init__(self, kind, local)</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">        self.__decl       = decl</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">        self.__scopedName = scopedName</span>
<a id="line253"></a><span class="lineno">253</span>
<a id="line254"></a><span class="lineno">254</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html#accept">accept</a>(self, visitor): visitor.visitDeclaredType(self)</span>
<a id="line255"></a><span class="lineno">255</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">    <span class="py-comment"># Decl object where the type was declared.</span></span>
<a id="line257"></a><span class="lineno">257</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html#decl">decl</a>(self):       <span class="py-keyword">return</span> self.__decl</span>
<a id="line258"></a><span class="lineno">258</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">    <span class="py-comment"># List containing scoped name:</span></span>
<a id="line260"></a><span class="lineno">260</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html#scopedName">scopedName</a>(self): <span class="py-keyword">return</span> self.__scopedName</span>
<a id="line261"></a><span class="lineno">261</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">    <span class="py-comment"># Simple name</span></span>
<a id="line263"></a><span class="lineno">263</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype/Declared.html#name">name</a>(self):       <span class="py-keyword">return</span> self.__scopedName[-1]</span>
<a id="line264"></a><span class="lineno">264</span>
<a id="line265"></a><span class="lineno">265</span>
<a id="line266"></a><span class="lineno">266</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#containsValueType">containsValueType</a>(t, track=None):</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Returns true if the type contains valuetypes&quot;&quot;&quot;</span></span>
<a id="line268"></a><span class="lineno">268</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">    <span class="py-keyword">import</span> idlast</span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">    <span class="py-keyword">if</span> track <span class="py-keyword">is</span> None:</span>
<a id="line272"></a><span class="lineno">272</span><span class="line">        track = {}</span>
<a id="line273"></a><span class="lineno">273</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">    <span class="py-keyword">if</span> track.has_key(id(t)):</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">        <span class="py-keyword">return</span> 0</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">    track[id(t)] = None</span>
<a id="line277"></a><span class="lineno">277</span>
<a id="line278"></a><span class="lineno">278</span><span class="line">    <span class="py-keyword">if</span> isinstance(t, Sequence):</span>
<a id="line279"></a><span class="lineno">279</span><span class="line">        <span class="py-keyword">return</span> containsValueType(t.seqType(), track)</span>
<a id="line280"></a><span class="lineno">280</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">    <span class="py-keyword">if</span> isinstance(t, Declared):</span>
<a id="line282"></a><span class="lineno">282</span><span class="line">        d = t.decl()</span>
<a id="line283"></a><span class="lineno">283</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.Declarator):</span>
<a id="line285"></a><span class="lineno">285</span><span class="line">            alias = d.alias()</span>
<a id="line286"></a><span class="lineno">286</span><span class="line">            <span class="py-keyword">if</span> alias:</span>
<a id="line287"></a><span class="lineno">287</span><span class="line">                <span class="py-keyword">return</span> containsValueType(alias.aliasType(), track)</span>
<a id="line288"></a><span class="lineno">288</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.Struct):</span>
<a id="line290"></a><span class="lineno">290</span><span class="line">            <span class="py-keyword">for</span> m <span class="py-keyword">in</span> d.members():</span>
<a id="line291"></a><span class="lineno">291</span><span class="line">                <span class="py-keyword">if</span> containsValueType(m.memberType(), track):</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">                    <span class="py-keyword">return</span> 1</span>
<a id="line293"></a><span class="lineno">293</span>
<a id="line294"></a><span class="lineno">294</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.Union):</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">            <span class="py-keyword">for</span> c <span class="py-keyword">in</span> d.cases():</span>
<a id="line296"></a><span class="lineno">296</span><span class="line">                <span class="py-keyword">if</span> containsValueType(c.caseType(), track):</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">                    <span class="py-keyword">return</span> 1</span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.ValueAbs):</span>
<a id="line300"></a><span class="lineno">300</span><span class="line">            <span class="py-keyword">return</span> 1</span>
<a id="line301"></a><span class="lineno">301</span>
<a id="line302"></a><span class="lineno">302</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.Value):</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">            <span class="py-keyword">return</span> 1</span>
<a id="line304"></a><span class="lineno">304</span>
<a id="line305"></a><span class="lineno">305</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.ValueBox):</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">            <span class="py-keyword">return</span> 1</span>
<a id="line307"></a><span class="lineno">307</span>
<a id="line308"></a><span class="lineno">308</span><span class="line">        <span class="py-keyword">if</span> isinstance(d, idlast.Interface) <span class="py-keyword">and</span> d.abstract():</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">            <span class="py-keyword">return</span> 1</span>
<a id="line310"></a><span class="lineno">310</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">    <span class="py-keyword">return</span> 0</span>
<a id="line312"></a><span class="lineno">312</span>
<a id="line313"></a><span class="lineno">313</span>
<a id="line314"></a><span class="lineno">314</span><span class="line"><span class="py-comment"># Map of singleton Base Type objects</span></span>
<a id="line315"></a><span class="lineno">315</span><span class="line">baseTypeMap = {</span>
<a id="line316"></a><span class="lineno">316</span><span class="line">    tk_null:       Base(tk_null),</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">    tk_void:       Base(tk_void),</span>
<a id="line318"></a><span class="lineno">318</span><span class="line">    tk_short:      Base(tk_short),</span>
<a id="line319"></a><span class="lineno">319</span><span class="line">    tk_long:       Base(tk_long),</span>
<a id="line320"></a><span class="lineno">320</span><span class="line">    tk_ushort:     Base(tk_ushort),</span>
<a id="line321"></a><span class="lineno">321</span><span class="line">    tk_ulong:      Base(tk_ulong),</span>
<a id="line322"></a><span class="lineno">322</span><span class="line">    tk_float:      Base(tk_float),</span>
<a id="line323"></a><span class="lineno">323</span><span class="line">    tk_double:     Base(tk_double),</span>
<a id="line324"></a><span class="lineno">324</span><span class="line">    tk_boolean:    Base(tk_boolean),</span>
<a id="line325"></a><span class="lineno">325</span><span class="line">    tk_char:       Base(tk_char),</span>
<a id="line326"></a><span class="lineno">326</span><span class="line">    tk_octet:      Base(tk_octet),</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">    tk_any:        Base(tk_any),</span>
<a id="line328"></a><span class="lineno">328</span><span class="line">    tk_TypeCode:   Base(tk_TypeCode),</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">    tk_Principal:  Base(tk_Principal),</span>
<a id="line330"></a><span class="lineno">330</span><span class="line">    tk_longlong:   Base(tk_longlong),</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">    tk_ulonglong:  Base(tk_ulonglong),</span>
<a id="line332"></a><span class="lineno">332</span><span class="line">    tk_longdouble: Base(tk_longdouble),</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">    tk_wchar:      Base(tk_wchar)</span>
<a id="line334"></a><span class="lineno">334</span><span class="line">    }</span>
<a id="line335"></a><span class="lineno">335</span>
<a id="line336"></a><span class="lineno">336</span><span class="line"><span class="py-comment"># Maps of String and WString Type objects, indexed by bound</span></span>
<a id="line337"></a><span class="lineno">337</span><span class="line">stringTypeMap =  { 0: String(0) }</span>
<a id="line338"></a><span class="lineno">338</span><span class="line">wstringTypeMap = { 0: WString(0) }</span>
<a id="line339"></a><span class="lineno">339</span>
<a id="line340"></a><span class="lineno">340</span><span class="line"><span class="py-comment"># Map of Sequence Type objects, indexed by (type object,bound)</span></span>
<a id="line341"></a><span class="lineno">341</span><span class="line">sequenceTypeMap = {}</span>
<a id="line342"></a><span class="lineno">342</span>
<a id="line343"></a><span class="lineno">343</span><span class="line"><span class="py-comment"># Map of Fixed Type objects, indexed by (digits,scale)</span></span>
<a id="line344"></a><span class="lineno">344</span><span class="line">fixedTypeMap = {}</span>
<a id="line345"></a><span class="lineno">345</span>
<a id="line346"></a><span class="lineno">346</span><span class="line"><span class="py-comment"># Map of declared type objects, indexed by stringified scoped name</span></span>
<a id="line347"></a><span class="lineno">347</span><span class="line">declaredTypeMap = {}</span>
<a id="line348"></a><span class="lineno">348</span>
<a id="line349"></a><span class="lineno">349</span>
<a id="line350"></a><span class="lineno">350</span><span class="line"><span class="py-comment"># Private functions to create or return existing Type objects</span></span>
<a id="line351"></a><span class="lineno">351</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#baseType">baseType</a>(kind):</span>
<a id="line352"></a><span class="lineno">352</span><span class="line">    <span class="py-keyword">return</span> baseTypeMap[kind]</span>
<a id="line353"></a><span class="lineno">353</span>
<a id="line354"></a><span class="lineno">354</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#stringType">stringType</a>(bound):</span>
<a id="line355"></a><span class="lineno">355</span><span class="line">    <span class="py-keyword">try</span>:</span>
<a id="line356"></a><span class="lineno">356</span><span class="line">        <span class="py-keyword">return</span> stringTypeMap[bound]</span>
<a id="line357"></a><span class="lineno">357</span><span class="line">    <span class="py-keyword">except</span> KeyError:</span>
<a id="line358"></a><span class="lineno">358</span><span class="line">        st = String(bound)</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">        stringTypeMap[bound] = st</span>
<a id="line360"></a><span class="lineno">360</span><span class="line">        <span class="py-keyword">return</span> st</span>
<a id="line361"></a><span class="lineno">361</span>
<a id="line362"></a><span class="lineno">362</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#wstringType">wstringType</a>(bound):</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">    <span class="py-keyword">try</span>:</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">        <span class="py-keyword">return</span> wstringTypeMap[bound]</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">    <span class="py-keyword">except</span> KeyError:</span>
<a id="line366"></a><span class="lineno">366</span><span class="line">        wst = WString(bound)</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">        wstringTypeMap[bound] = wst</span>
<a id="line368"></a><span class="lineno">368</span><span class="line">        <span class="py-keyword">return</span> wst</span>
<a id="line369"></a><span class="lineno">369</span>
<a id="line370"></a><span class="lineno">370</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#sequenceType">sequenceType</a>(type_spec, bound, local):</span>
<a id="line371"></a><span class="lineno">371</span><span class="line">    <span class="py-keyword">try</span>:</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">        <span class="py-keyword">return</span> sequenceTypeMap[(type_spec,bound)]</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">    <span class="py-keyword">except</span> KeyError:</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">        st = Sequence(type_spec, bound, local)</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">        sequenceTypeMap[(type_spec,bound)] = st</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">        <span class="py-keyword">return</span> st</span>
<a id="line377"></a><span class="lineno">377</span>
<a id="line378"></a><span class="lineno">378</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#fixedType">fixedType</a>(digits, scale):</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">    <span class="py-keyword">try</span>:</span>
<a id="line380"></a><span class="lineno">380</span><span class="line">        <span class="py-keyword">return</span> fixedTypeMap[(digits,scale)]</span>
<a id="line381"></a><span class="lineno">381</span><span class="line">    <span class="py-keyword">except</span> KeyError:</span>
<a id="line382"></a><span class="lineno">382</span><span class="line">        ft = Fixed(digits, scale)</span>
<a id="line383"></a><span class="lineno">383</span><span class="line">        fixedTypeMap[(digits,scale)] = ft</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">        <span class="py-keyword">return</span> ft</span>
<a id="line385"></a><span class="lineno">385</span>
<a id="line386"></a><span class="lineno">386</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#declaredType">declaredType</a>(decl, scopedName, kind, local):</span>
<a id="line387"></a><span class="lineno">387</span><span class="line">    sname = idlutil.slashName(scopedName)</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">    <span class="py-keyword">if</span> declaredTypeMap.has_key(sname):</span>
<a id="line389"></a><span class="lineno">389</span><span class="line">        dt = declaredTypeMap[sname]</span>
<a id="line390"></a><span class="lineno">390</span><span class="line">        <span class="py-keyword">if</span> dt.kind() == kind:</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">            <span class="py-keyword">return</span> dt</span>
<a id="line392"></a><span class="lineno">392</span><span class="line">    dt = Declared(decl, scopedName, kind, local)</span>
<a id="line393"></a><span class="lineno">393</span><span class="line">    declaredTypeMap[sname] = dt</span>
<a id="line394"></a><span class="lineno">394</span><span class="line">    <span class="py-keyword">return</span> dt</span>
<a id="line395"></a><span class="lineno">395</span>
<a id="line396"></a><span class="lineno">396</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/IDL/idltype.html#clear">clear</a>():</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Clear back-end structures ready for another run&quot;&quot;&quot;</span></span>
<a id="line398"></a><span class="lineno">398</span><span class="line">    stringTypeMap.clear()</span>
<a id="line399"></a><span class="lineno">399</span><span class="line">    wstringTypeMap.clear()</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">    sequenceTypeMap.clear()</span>
<a id="line401"></a><span class="lineno">401</span><span class="line">    fixedTypeMap.clear()</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">    declaredTypeMap.clear()</span>
<a id="line403"></a><span class="lineno">403</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
